# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
#
# Copyright (C) 2013 Canonical Ltd.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation; version 3.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

from ubuntuuitoolkit import emulators as toolkit_emulators

class MainView(toolkit_emulators.MainView):

    #ideally this should be converted to the sdk and use object name not text names
    #see https://bugs.launchpad.net/ubuntu-ui-toolkit/+bug/1205144
    def run_action(self, popover, name):
        actions = popover.select_many("Empty")
        requested = None
        for action in actions:
            if action.text == name:
                requested = action
        self.pointing_device.click_object(requested)

    def get_action_popover(self):
        # Returns all instances, but with current one as first index
        return self.select_many("ActionSelectionPopover")[0]

    def get_append_page(self):
        return self.select_single("AppendFeedPage", objectName = "appendfeedpage")

    def get_feedlist_page(self):
        return self.select_single("FeedListPage", objectName = "feedlistpage")

    def get_articlelist_page(self):
        return self.select_single("ArticleListPage", objectName = "articlelistpage")

    def get_feed_management_page(self):
        return self.select_single("TopicManagement", objectName = "topicmanagement")

    def get_edit_feed_page(self):
        return self.select_single("EditFeed", objectName = "editfeedpage")

    def get_checkbox_button(self):
        return self.select_single("CheckBox", objectName = "feedCheckbox")

    def get_delete_button(self):
        return self.select_single("Button", objectName = "deleteButton")

    def get_next_button(self):
        return self.select_single("Button", objectName = "nextButton")

    def get_append_feed_input_box(self):
        return self.select_single("TextField", objectName = "tfFeedUrl")

    def get_new_topic_input_box(self):
        return self.select_single("TextField", objectName = "New topic")

    def get_topics_page(self):
        return self.select_single("ChooseTopicPage", objectName = "choosetopicpage")

    def get_topics(self):
        return self.select_single("QQuickListView", objectName = "topiclist")

    def get_manage_topics_page(self):
         return self.select_single("ManageTopicsPage")

    def get_canonical_topic(self):
        itemList = self.select_many("LabelVisual", text = "CanonicalTopic")
        for item in itemList:
            if item.text == "CanonicalTopic":
                return item

    def get_canonical_feed_labelvisual(self):
        itemList = self.select_many("LabelVisual", text = "Canonical")
        for item in itemList:
            if item.text == "Canonical":
                return item

    def get_feeds(self):
        return self.select_many("Standard", objectName = "FeedListItem")

    def get_canonical_feed(self):
        itemList = self.get_feeds()
        for item in itemList:
            if item.text == "Canonical":
               return item

    def get_header(self):
        return self.select_many("Header")

    def get_all_feeds(self):
        return self.select_single("Subtitled", text = "All articles")

    def get_refresh_button(self):
        return self.select_single("AbstractButton", objectName = "refreshbutton")

    def get_list_view_button(self):
        return self.select_single("AbstractButton", objectName = "listviewbutton")

    def get_add_feed_button(self):
        return self.select_single("AbstractButton", objectName = "addfeedbutton")

    def get_edit_topic_button(self):
        return self.select_single("AbstractButton", objectName = "edittopicbutton")

    def get_canonical_topic_labelvisual(self):
        itemList = self.select_many("LabelVisual", text = "CanonicalTopic")
        for item in itemList:
            if item.text == "CanonicalTopic":
               return item

    def get_canonical_topic_TopicComponent(self):
        itemList = self.select_many("TopicComponent", topicName= "CanonicalTopic")
        for item in itemList:
                if item.topicName == "CanonicalTopic":
                    return item

    def get_canonical_feed_FeedComponent(self):
        return self.select_single("FeedComponent", text = "Canonical")

    def get_add_a_topic(self):
        return self.select_single("QQuickItem", objectName = "addTopic")
